OpenTTD Source: GenericResolverObject Struct Reference

OpenTTD Source 15.0-RC2

Public Member Functions | Data Fields
GenericResolverObject Struct Reference

Resolver object for generic objects/properties. More...

Inheritance diagram for GenericResolverObject:

## Public Member Functions
| GenericResolverObject (bool ai_callback, CallbackID callback=CBID_NO_CALLBACK)
| Generic resolver.
ScopeResolver * | GetScope (VarSpriteGroupScope scope=VSG_SCOPE_SELF, uint8_t relative=0) override
| Get a resolver for the scope.
GrfSpecFeature | GetFeature () const override
| Get the feature number being resolved for.
uint32_t | GetDebugID () const override
| Get an identifier for the item being resolved.
Public Member Functions inherited from ResolverObject
| ResolverObject (const GRFFile *grffile, CallbackID callback=CBID_NO_CALLBACK, uint32_t callback_param1=0, uint32_t callback_param2=0)
| Resolver constructor.
ResolverResult | DoResolve ()
int32_t | GetRegister (uint i) const
| Gets the value of a so-called newgrf "register".
void | SetRegister (uint i, int32_t value)
| Sets the value of a so-called newgrf "register".
template<class TSpriteGroup >
const TSpriteGroup * | Resolve ()
| Resolve SpriteGroup.
void | ResolveRerandomisation ()
| Resolve bits to be rerandomised.
CallbackResult | ResolveCallback (std::span< int32_t > regs100)
| Resolve callback.
virtual const SpriteGroup * | ResolveReal (const RealSpriteGroup &group) const
| Get the real sprites of the grf.
uint32_t | GetWaitingRandomTriggers () const
| Used by RandomizedSpriteGroup: Triggers for rerandomisation.
void | AddUsedRandomTriggers (uint32_t triggers)
| Used by RandomizedSpriteGroup: Consume triggers.
uint32_t | GetReseedSum () const
| Returns the OR-sum of all bits that need reseeding independent of the scope they were accessed with.

## Data Fields
GenericScopeResolver | generic_scope
Data Fields inherited from ResolverObject
ScopeResolver | default_scope
| Default implementation of the grf scope.
CallbackID | callback {}
| Callback being resolved.
uint32_t | callback_param1 = 0
| First parameter (var 10) of the callback.
uint32_t | callback_param2 = 0
| Second parameter (var 18) of the callback.
uint32_t | last_value = 0
| Result of most recent DeterministicSpriteGroup (including procedure calls)
std::array< uint32_t, VSG_END > | reseed
| Collects bits to rerandomise while triggering triggers.
const GRFFile * | grffile = nullptr
| GRFFile the resolved SpriteGroup belongs to.
const SpriteGroup * | root_spritegroup = nullptr
| Root SpriteGroup to use for resolving.

## Additional Inherited Members
Protected Attributes inherited from ResolverObject
uint32_t | waiting_random_triggers = 0
| Waiting triggers to be used by any rerandomisation. (scope independent)
uint32_t | used_random_triggers = 0
| Subset of cur_triggers, which actually triggered some rerandomisation. (scope independent)

## Detailed Description

Resolver object for generic objects/properties.

Definition at line 52 of file newgrf_generic.cpp.

## Constructor & Destructor Documentation

## ◆ GenericResolverObject()

GenericResolverObject::GenericResolverObject | ( | bool | ai_callback,
|  | CallbackID | callback = `CBID_NO_CALLBACK`
| ) |  |

Generic resolver.

Parameters

  ai_callback | Callback comes from the AI.
  callback | Callback ID.

Definition at line 152 of file newgrf_generic.cpp.

## Member Function Documentation

## ◆ GetDebugID()

uint32_t GenericResolverObject::GetDebugID | ( |  | ) | const
| inlineoverridevirtual

Get an identifier for the item being resolved.

This function is mainly intended for the callback profiling feature, and should return an identifier recognisable by the NewGRF developer.

Reimplemented from ResolverObject.

Definition at line 70 of file newgrf_generic.cpp.

## ◆ GetFeature()

GrfSpecFeature GenericResolverObject::GetFeature | ( |  | ) | const
| inlineoverridevirtual

Get the feature number being resolved for.

This function is mainly intended for the callback profiling feature.

Reimplemented from ResolverObject.

Definition at line 65 of file newgrf_generic.cpp.

## ◆ GetScope()

ScopeResolver * GenericResolverObject::GetScope | ( | VarSpriteGroupScope | scope = `VSG_SCOPE_SELF`,
|  | uint8_t | relative = `0`
| ) |  |
| inlineoverridevirtual

Get a resolver for the scope.

Returns
  The resolver for the requested scope.

Reimplemented from ResolverObject.

Definition at line 57 of file newgrf_generic.cpp.

References ResolverObject::GetScope(), and VSG_SCOPE_SELF.

## Field Documentation

## ◆ generic_scope

GenericScopeResolver GenericResolverObject::generic_scope

Definition at line 53 of file newgrf_generic.cpp.

The documentation for this struct was generated from the following file:

- src/newgrf_generic.cpp